SystemOrganization addCategory: #BackgammonController!

Object subclass: #BackgammonStart
	instanceVariableNames: 'myBoardModel myBoardView observables diceView1 diceView2 portListen portSend isServerGame playerNum'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BackgammonController'!

BackgammonStart class
	instanceVariableNames: 'messageSelectorAndArgumentNames instance'!

!BackgammonStart commentStamp: 'DavidOvergaard 7/16/2015 21:27' prior: 0!
Initialize and run backgammon game!

BackgammonStart class
	instanceVariableNames: 'messageSelectorAndArgumentNames instance'!

!BackgammonStart class methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/30/2015 19:48'!
connectToNetworkGameOn: portToListenForData sendDataOn: portToSendData
	instance := BackgammonStart new connectToNetworkGameOn: portToListenForData sendDataOn: portToSendData.
	^instance.! !

!BackgammonStart class methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/30/2015 19:48'!
getInstance
	(instance isNil) ifTrue:[Transcript show: 'ERROR:instance should have been initialized'].
	^instance.! !

!BackgammonStart class methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/30/2015 19:48'!
start
   instance := BackgammonStart new start.
	^instance.! !

!BackgammonStart class methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/30/2015 19:49'!
startNetworkGameOn: portToSendData listenOn: portToListenForData
	instance := BackgammonStart new startNetworkGameOn: portToSendData listenOn: portToListenForData.
	^instance! !

!BackgammonStart methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/30/2015 22:59'!
connectToNetworkGameOn: portToListenForData sendDataOn: portToSendData
	| hostToListen initialHello secondsWaited maxTimeout |
	portListen := portToListenForData.
	portSend := portToSendData.
	(self start).
	
	(ZnServer startDefaultOn: portToSendData)
	   onRequestRespond: [ :request | 
		ZnResponse ok: (ZnEntity text: 'Player2 joined') ].
	
	hostToListen := 'http://localhost:', (portToListenForData asString).
	secondsWaited := 0.
	maxTimeout := 3.
	[(initialHello isNil) & (secondsWaited < maxTimeout)] whileTrue: [ 
		[initialHello := (ZnEasy get: hostToListen) entity string] on: Error  do: [ :e |
		initialHello := nil.
		Transcript show: 'delaying 1 sec' ; cr.
		(Delay forSeconds: 1) wait.
		secondsWaited := secondsWaited + 1.
		].
		 ].
	
	(initialHello isNil)
	ifTrue: [
		MorphicUIManager default alert: 'Connection timeout, try to connect again.' title: 'Connection error'
		 ]
	ifFalse: [ 
		MorphicUIManager default alert: 'Connected to player 1' title: 'Game setup'.
		isServerGame := 1.
		playerNum := 2.
		].
"	Transcript show: initialHello; cr."! !

!BackgammonStart methodsFor: 'as yet unclassified' stamp: 'AhmedSoliman 7/24/2015 14:17'!
displayBoardDice
	| boardHeight boardWidth |
	boardHeight := myBoardView getBoardSize y.	"Add the dice to the board"
	boardWidth := myBoardView getBoardSize x.
	diceView1 := DieView dieModel: myBoardModel dice1.
	myBoardView addMorph: (diceView1 dieMorph
		left: boardWidth / 2 - 50 - 50;
		top: boardHeight / 2 - 15).
	diceView2 := DieView dieModel: myBoardModel dice2.
	myBoardView addMorph: (diceView2 dieMorph
		left: boardWidth / 2 + 50 - 50;
		top: boardHeight / 2 - 15)! !

!BackgammonStart methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/30/2015 23:00'!
isServerGame
	^isServerGame.! !

!BackgammonStart methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/16/2015 22:01'!
model
	^myBoardModel.! !

!BackgammonStart methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/16/2015 22:23'!
observable: anObject
	observables add: anObject.! !

!BackgammonStart methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/16/2015 22:16'!
observables
	^observables! !

!BackgammonStart methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/30/2015 19:46'!
player1ExchangeStringBlocking: stringToSend
	"Name set, wait for player 2 to set name"	
	| controller listenURL  player2Response |
	controller := (BackgammonStart getInstance).
	
	(ZnServer startDefaultOn: (controller portSend))
	   onRequestRespond: [ :request | 
		ZnResponse ok: (ZnEntity text: '1') ].
			
	"Ensure that next message from player 2 is their name"
	listenURL := ('http://localhost:', (controller portListen asString)).
	player2Response := (ZnEasy get: listenURL) entity string.			
	[(player2Response = '1')] whileFalse: [
		player2Response := (ZnEasy get: listenURL) entity string.
		Transcript show: 'delaying 1 sec' ; cr.
		Transcript show: player2Response ; cr.
		(Delay forSeconds: 1) wait.
	 ].
								
	"Send player 1 name now that both games are in the same waiting state"
	(ZnServer startDefaultOn: (controller portSend))
	   onRequestRespond: [ :request | 
		ZnResponse ok: (ZnEntity text: stringToSend) ].
		
	"Get player 2 name"
	[player2Response = '1'] whileTrue: [
		player2Response := (ZnEasy get: listenURL) entity string.
		Transcript show: 'delaying 1 sec' ; cr.
		(Delay forSeconds: 1) wait.
	 ].

	^player2Response.! !

!BackgammonStart methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/30/2015 19:46'!
player2ExchangeStringBlocking: stringToSend
	"Name set, wait for player 2 to set name"	
	| controller listenURL player1Response  |
	controller := (BackgammonStart getInstance).
	
	"Ensure that next message from player 2 is their name"
	listenURL := ('http://localhost:', (controller portListen asString)).
	player1Response := (ZnEasy get: listenURL) entity string.			
	[(player1Response = '1')] whileFalse: [
		player1Response := (ZnEasy get: listenURL) entity string.
		Transcript show: 'delaying 1 sec' ; cr.
		Transcript show: player1Response ; cr.
		(Delay forSeconds: 1) wait.
	 ].
		
	"Name set, wait for player 2 to set name"	
	(ZnServer startDefaultOn: (controller portSend))
	   onRequestRespond: [ :request | 
		ZnResponse ok: (ZnEntity text: '1') ].

	"Get player 2 name"
	[player1Response = '1'] whileTrue: [
		player1Response := (ZnEasy get: listenURL) entity string.
		Transcript show: 'delaying 1 sec' ; cr.
		(Delay forSeconds: 1) wait.
	 ].
		
	"Send player 1 name now that both games are in the same waiting state"
	(ZnServer startDefaultOn: (controller portSend))
	   onRequestRespond: [ :request | 
		ZnResponse ok: (ZnEntity text: stringToSend)].
	
	^player1Response.! !

!BackgammonStart methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/30/2015 19:46'!
playerNum
	^playerNum.! !

!BackgammonStart methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/30/2015 19:46'!
portListen
	^portListen.! !

!BackgammonStart methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/30/2015 19:47'!
portSend
	^portSend.! !

!BackgammonStart methodsFor: 'as yet unclassified' stamp: 'AhmedSoliman 7/24/2015 13:59'!
promptForPlayersNames
	"Ask each player in turn about their name and update the model"
	"Prompt for player 1"
	| player1Name player2Name |
	player1Name := UIManager default request: 'Player 1 name:' initialAnswer: 'Ahmed'.
	myBoardModel player1 nameOfPlayer: player1Name.
	
	"Prompt for player 2"
	player2Name := UIManager default request: 'Player 2 name:' initialAnswer: 'Bob'.
	myBoardModel player2 nameOfPlayer: player2Name.
	
	"myBoardView displayNameForPlayer1: player1Name  Player2: player2Name"  ! !

!BackgammonStart methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/30/2015 22:59'!
start
	| diceButton turnButton |

	myBoardModel := MainBoard newGame.
		
	myBoardView := BackgammonBoard createNewBoard: self.
	myBoardModel player1Checkers
		do: [ :aChecker | 
			myBoardView addCheckerAtPoint: aChecker checkerLocation pointNumber color: aChecker color.
			aChecker addObserver: myBoardView lastAddedChecker ].
	myBoardModel player2Checkers
		do: [ :aChecker | 
			myBoardView addCheckerAtPoint: aChecker checkerLocation pointNumber color: aChecker color.
			aChecker addObserver: myBoardView lastAddedChecker ].	"Test move with observer"

	self displayBoardDice.	
	
	diceButton := InputButton text: 'Roll dice' boardHeight: (myBoardView getBoardSize y).
	"diceButton mouseAction: [ diceButton rollDie: myBoardModel. ]."
	myBoardView addMorph: diceButton.	"self promptForPlayersNames ."	"Add the dice to the board"
	turnButton := EndTurnButton text: 'End turn' boardHeight: (myBoardView getBoardSize y).
	myBoardView addMorph: turnButton.

	"self promptForPlayersNames .	"
	
	myBoardView drawBearOffChecker1With: (myBoardModel player1BOChecker).
	myBoardView drawBearOffChecker2With: (myBoardModel player2BOChecker).
	myBoardModel offLocationP1 addObserver: (myBoardModel player1BOChecker).
	myBoardModel offLocationP2 addObserver: (myBoardModel player2BOChecker).
	
	"This is updated in the server specific initializtion"
	isServerGame := 0.
	playerNum := 0.! !

!BackgammonStart methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/30/2015 22:59'!
startNetworkGameOn: portToSendData listenOn: portToListenForData
	| hostToListen initialHello secondsWaited maxTimeout |
	portListen := portToListenForData.
	portSend := portToSendData.
	(self start).
	
	hostToListen := 'http://localhost:', (portToListenForData asString).
	
	secondsWaited := 0.
	maxTimeout := 3.
	[(initialHello isNil) & (secondsWaited < maxTimeout)] whileTrue: [ 
		[initialHello := (ZnEasy get: hostToListen) entity string] on: Error  do: [ :e |
		initialHello := nil.
		Transcript show: 'delaying 1 sec' ; cr.
		(Delay forSeconds: 1) wait.
		secondsWaited := secondsWaited + 1.
		].
		 ].
	
	(initialHello isNil)
	ifTrue: [
		MorphicUIManager default alert: 'Connection timeout, try to connect again.' title: 'Connection error'
		 ]
	ifFalse: [ 
		MorphicUIManager default alert: 'Player 2 connected' title: 'Game setup'.
		(ZnServer startDefaultOn: portToSendData)
		   onRequestRespond: [ :request | 
			ZnResponse ok: (ZnEntity text: 'Player1 joined') ].
		
		isServerGame := 1.
		playerNum := 1.
		].
"	Transcript show: initialHello; cr."! !

!BackgammonStart methodsFor: 'as yet unclassified' stamp: 'jChizmar 7/24/2015 22:37'!
updatedBearOffCheckerCountByColor:aColor checker:aChecker
| modelChecker moveCheckerCommand playerOff   |
	(aColor = (self model player1 checkerColor))
			ifTrue: [ 
				"self model offLocationP1 incrementNumCheckersOnHome"
				
				playerOff := self model offLocationP1.
			 ]
			ifFalse: [ 
				"self model offLocationP2 incrementNumCheckersOnHome"
				playerOff := self model offLocationP2.
			 ].
	modelChecker :=  aChecker.
	
	moveCheckerCommand := (MoveCheckerCommand new) checker: modelChecker location: playerOff.

	moveCheckerCommand execute.! !

!BackgammonStart methodsFor: 'as yet unclassified' stamp: 'jChizmar 7/28/2015 22:39'!
updatedChecker: aChecker toHome: pointNum
	| modelChecker moveCheckerCommand |
"	Transcript show: (aChecker location)."
	modelChecker := aChecker observable.
	
	(pointNum = 25)
	ifTrue: [ 
		 	moveCheckerCommand := (MoveCheckerCommand new) checker: modelChecker location: (myBoardModel player1Off).
		 ]
	ifFalse: [ 
		(pointNum = 26)
		ifTrue: [
				 	moveCheckerCommand := (MoveCheckerCommand new) checker: modelChecker location: (myBoardModel player2Off).
			].
		].
	[moveCheckerCommand execute.] on: Error do:
			[:e | 
			MorphicUIManager default alert: (e messageText) title: 'Invalid move'].! !

!BackgammonStart methodsFor: 'as yet unclassified' stamp: 'jChizmar 7/28/2015 22:39'!
updatedChecker: aChecker toPointNum: pointNum
	| modelChecker moveCheckerCommand |
"	Transcript show: (aChecker location)."
	modelChecker := aChecker observable.
	moveCheckerCommand := (MoveCheckerCommand new) checker: modelChecker location: (myBoardModel points at: pointNum).
	
	[moveCheckerCommand execute.] on: Error do:
			[:e | 
			MorphicUIManager default alert: (e messageText) title: 'Invalid move'].! !

!BackgammonStart methodsFor: 'as yet unclassified' stamp: 'DavidOvergaard 7/16/2015 22:02'!
view
	^myBoardView := BackgammonBoard createNewBoard.! !
